Package org.osgi.framework

# Interface BundleActivator

@ConsumerType public interface BundleActivator
Customizes the starting and stopping of a bundle.

`BundleActivator` is an interface that may be implemented when a bundle is started or stopped. The Framework can create instances of a bundle's `BundleActivator` as required. If an instance's `BundleActivator.start` method executes successfully, it is guaranteed that the same instance's `BundleActivator.stop` method will be called when the bundle is to be stopped. The Framework must not concurrently call a `BundleActivator` object.

`BundleActivator` is specified through the `Bundle-Activator` Manifest header. A bundle can only specify a single `BundleActivator` in the Manifest file. Fragment bundles must not have a `BundleActivator`. The form of the Manifest header is:

`Bundle-Activator:` class-name

where class-name is a fully qualified Java classname.

The specified `BundleActivator` class must have a public constructor that takes no parameters so that a `BundleActivator` object can be created by `Class.newInstance()`.

## Method Summary

Modifier and Type
Method
Description
`void`
`start(BundleContext context)`
Called when this bundle is started so the Framework can perform the bundle-specific activities necessary to start this bundle.
`void`
`stop(BundleContext context)`
Called when this bundle is stopped so the Framework can perform the bundle-specific activities necessary to stop the bundle.

## Method Details

### start

void start(BundleContext context) throws Exception
Called when this bundle is started so the Framework can perform the bundle-specific activities necessary to start this bundle. This method can be used to register services or to allocate any resources that this bundle needs.

This method must complete and return to its caller in a timely manner.

Parameters:
  `context` - The execution context of the bundle being started.
Throws:
  `Exception` - If this method throws an exception, this bundle is marked as stopped and the Framework will remove this bundle's listeners, unregister all services registered by this bundle, and release all services used by this bundle.

### stop

void stop(BundleContext context) throws Exception
Called when this bundle is stopped so the Framework can perform the bundle-specific activities necessary to stop the bundle. In general, this method should undo the work that the `BundleActivator.start` method started. There should be no active threads that were started by this bundle when this bundle returns. A stopped bundle must not call any Framework objects.

This method must complete and return to its caller in a timely manner.

Parameters:
  `context` - The execution context of the bundle being stopped.
Throws:
  `Exception` - If this method throws an exception, the bundle is still marked as stopped, and the Framework will remove the bundle's listeners, unregister all services registered by the bundle, and release all services used by the bundle.